System.usbDiskModeActivate()
white = Color.new(255,255,255)
black = Color.new(0,0,0)
gray = Color.new(100,100,100)


charX = 0
charY = 0
newCX = ""
newCY = ""
--First frame - Idle
charAniX = 24
charAniY = 64
speed = 8
loop = 0
dir = "none"
screenOffSetX = 0
screenOffSetY = 8 
battle = 1

offSetX = 224
offSetY = 128

char = Image.load("char.png")
map1 = Image.load("map1.png")
dialogueBG = Image.load("dialogue.png")
currentMap = Image.createEmpty(352, 256)

function length(ar)
len = 0
	for j,jj in ar do
	len = len+1
	end
return len
end

function split(str)
a = string.find(str, "|")
str = string.gsub(str, "|", "", 1)
aCount = 0
start = 1
array = {}
last = 0

	while a do
	
	array[aCount] = string.sub(str, start, a - 1)
	start = a
	a = string.find(str, "|")
	
	str = string.gsub(str, "|", "", 1)
	aCount = aCount + 1
	end
	
return array
end

function dSplit(str)
newStr = {}
n = 0
k = 0
	while true do
	pN = n
	n = string.find(str, " ", n+1)
	
		if string.len(str) < 33 or n == nil then -- >
		newStr[length(newStr)] = str
		return newStr
		end
		
		if n > 33 then
			if string.find(str, " ") == 1 then
			newStr[length(newStr)] = string.sub(str, 2, pN-2)
			str = string.sub(str, pN-1)
			else
			newStr[length(newStr)] = string.sub(str, 1, pN)
			str = string.sub(str, pN)
			end
		k = k + 1 
		end
					
		pad = Controls.read()
		if pad:select() then
		break
		end
	end
end

function createMap(map)
file = io.open(map..".txt", "r")
mapImage = Image.load(map..".png")
	if file then
	objects = {}
	teleports = {}
	npc = {}
	enemy = {}
	defeated = {}
	oCount = 0
	tCount = 0
	nCount = 0
	eCount = 0
	thisMap = map
	charAniY = 64
		currentMap:clear()
		if newCX == "" and newCY == "" then
		charX = tonumber(file:read("*line"))*32
		charY = tonumber(file:read("*line"))*32
		else
		charX = newCX
		charY = newCY
		newCX = ""
		newCX = ""
		map = file:read("*line")
		map = file:read("*line")
		end
		
		map = file:read("*line")
		
		count = 0
		
			while 8 >= count  do
			map = string.sub(map, 0, string.len(map) - 2)

			h = 0
				while h <= (string.len(map)/3)-1 do -->
				
				if tonumber(string.sub(map, h*3+3, h*3+3)) == 1 then
				objects[oCount] = {h, count}
				oCount = oCount + 1
				end
				
				currentMap:blit(h * 32, count*32, mapImage, tonumber(string.sub(map, h * 3 + 1, h * 3 + 1)) *32, tonumber(string.sub(map, h * 3 + 2, h * 3+ 2)) * 32, 32, 32, false)
				h = h + 1
				end
			mapWidth = h
			map = file:read("*line")
			count = count + 1
			end
		
		while map do
			if string.sub(map, 1, 8) == "teleport" then
			data = split(map)
			--                            X and Y on Map     map    new CharX and Y
			teleports[tCount] = {tonumber(data[2]), tonumber(data[3]), data[1], tonumber(data[4]), tonumber(data[5])}
			tCount = tCount + 1
			end
			
			
			
			if string.sub(map, 1, 5) == "enemy" then
			data = split(map)
			--                            X and Y on Map         EnemyName       Load                          Walking?
			enemy[eCount] = {tonumber(data[2]), tonumber(data[3]), data[1], Image.load(data[1] .. ".png"), tonumber(data[4]), tonumber(data[5])}
			eCount = eCount + 1
			end
			
			
			
			if string.sub(map, 1, 3) == "npc" then
			data = split(map)
			--                 X and Y on Map      image    rand?  dialogue
			npc[nCount] = {tonumber(data[2]), tonumber(data[3]), data[1], data[4], data[5], Image.load(data[1] .. ".png"), 24, 64}
			
			--Make solid
			objects[oCount] = {tonumber(data[2]), tonumber(data[3])}
			
			oCount = oCount + 1
			nCount = nCount + 1
			end
			
		map = file:read("*line")
		end 
		
		
		file:close()
		mapHeight = count
	end
end


function blitMap(x, y)
screen:blit(x, y, currentMap)

--Blit NPCs
for o,dd in npc do
screen:blit(dd[1]*32+6, dd[2]*32, dd[6], dd[7], dd[8], 24, 32)
end

--Blit Enemys
dblit = 0
for o,dd in enemy do
	for l,ll in defeated do
	if ll[1] == dd[1] and ll[2] == dd[2] then
	dblit = 1 
	end
	end
	
	if dblit == 0 then
	screen:blit(dd[1]*32+6, dd[2]*32, dd[4], 0, 0, 24, 32)
	dblit = 0
	end
end

end



function collision(Cx, Cy, Cdir)
hit = 0
	for o,coor in objects do
		
		if Cdir == "left" and Cx == coor[1]*32+32 and Cy == coor[2]*32 then
		hit = 1
		end
		
		if Cdir == "right" and Cx == coor[1]*32-32 and Cy == coor[2]*32 then
		hit = 1
		end
		
		if Cdir == "up" and Cx == coor[1]*32 and Cy == coor[2]*32+32 then
		hit = 1
		end
		
		if Cdir == "down" and Cx == coor[1]*32 and Cy == coor[2]*32-32 then
		hit = 1
		end
		
		
	end


	if hit == 1 then
	return true
	else
	return false
	end
end



function teleport(Cx, Cy)
t = 0
	for o,coor in teleports do
		if Cx == coor[1]*32 and Cy == coor[2]*32 then
		t = coor
		ncx = Cx
		ncy = Cy
		end	
	end

	if t == 0 then
	return false
	else

	newCX = tonumber(t[4]) * 32
	newCY = tonumber(t[5]) * 32

	return t[3]
	end
end


function dialogue(text, person)
	blitMap(0, 0)
	screen:blit(charX + 6, charY, char, aniX, aniY, 24, 32, true)
	screen:blit(16, 184, dialogueBG)
	if 22 >= string.len(text) then
	screen:print(25, 192, person .. ": " .. text, white)
	else
		for e,l in dSplit(person .. ": " .. text) do
		screen:print(25, 192 + (e*10), l, white)
		end
	end
	
	screen:flip()
	screen.waitVblankStart(20)
		while true do
		pad = Controls.read()
		if pad:cross() then
		break
		end
		screen.waitVblankStart(7)
	end
	screen.waitVblankStart(10)
end


function battleDraw()
screen:clear()

screen:blit(0, 0, battleBG)	
screen:blit(16, 191, bottom)

if yourTurn == 1 then
	
	if menu == 0 then
	screen:blit(15, 188+(pY*11), pointer)
	screen:print(30, 200, "Attack", white)	
	screen:print(30, 211, "Magic", white)			
	screen:print(30, 222, "Item", white)	

	elseif menu == 1 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in attacks do
	screen:print(30, 200 + (key*10), a, white)	
	end

	elseif menu == 2 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in magic do
	screen:print(30, 200 + (key*10), a, white)	
	end

	elseif menu == 3 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in items do
	screen:print(30, 200 + (key*10), a, white)	
	end
	end

else
screen:print(30, 200, "Attack", gray)	
screen:print(30, 211, "Magic", gray)			
screen:print(30, 222, "Item", gray)	
end



screen:print(135, 200, "Hero:", white)
screen:blit(180, 200, bar, 0, 0, barProgress, bar:height(), true)	
screen:blit(180, 200, barBack, 0, 0, bar:width(), bar:height(), true)
hp = "HP: " .. hpLeft .. "/" .. hpTotal	
screen:print(320 - (string.len(hp) * 8), 200, hp, white)
end


function battle(enemyName, enX, enY)
charBattle = Image.load("char_battle.png")	
baddyImage = Image.load(enemyName .. ".png")	
bottom = Image.load("battle_bottom.png")		
battleBG = Image.load("bgs/grass.png")
barBack = Image.load("bar_back.png")		
bar = Image.load("bar.png")
pointer = Image.load("pointer.png")
pow = Image.load("effects/pow.png")

menu = 0
menu2 = 0								
pY = 1
p2Y = 1
ani = 0
yourTurn = 0
barProgress = 0

if enemyName == "skull" then
enemyHPleft = 10
enemyHPtotal = 10
enemySpeed = 1
end

enemyTurn = 0
enemyBarProgress = 0

	while true do

	pad = Controls.read()
	
	if pad:select() then
	defeated[table.getn(defeated)] = {enX, enY}
	break
	end

	--Fresh Screen and BG
	screen:clear()
	screen:blit(0, 0, battleBG)	

screen:print(5, 5, enemyHPleft .. "/" .. enemyHPtotal, black)



if yourTurn == 1 and menu2 > 0 then
	if menu == 1 then
	f = attacks
	end
	
	if menu == 2 then
	f = magic
	end
	
	if menu == 3 then
	f = items
	end

	screen:print(205, 260, f[menu2-1], white)

	action = f[menu2-1]



-- ***** List of attacks, magic, and items go here with each of their animations... *****
	if action == "Stab" then
	dofile "attacks/Stab.lua"
	end

	
	--Fresh Screen and BG
	screen:clear()
	screen:blit(0, 0, battleBG)	

	yourTurn = 0
	menu = 0
	menu2 = 0
	barProgress = 0


elseif enemyTurn == 1 then
	
	if enemyName == "skull" then
	dofile "attacks/Head Throw.lua"
	end

enemyTurn = 0
enemyBarProgress = 0

elseif yourTurn == 1 and menu == 0 then
	if pad:down() then
	pY = pY + 1
	end
	if pad:up() then
	pY = pY - 1
	end
	if pY == 0 then
	pY = 3
	end
	if pY == 4 then
	pY = 1
	end
	if pad:cross() then
	menu = pY
	end


elseif yourTurn == 1 and menu > 0 then
	if menu == 1 then
	f = attacks
	end
	
	if menu == 2 then
	f = magic
	end
	
	if menu == 3 then
	f = items
	end
	
	if pad:down() then
	p2Y = p2Y + 1
	end
	if pad:up() then
	p2Y = p2Y - 1
	end
	if p2Y == 0 then
	p2Y = length(f)-1
	end
	if p2Y == length(f)+1 then
	p2Y = 1
	end

	if pad:cross() then
	menu2 = p2Y
	end
	if pad:circle() then
	menu = 0
	end
end




--Menu
screen:blit(16, 191, bottom)

if yourTurn == 1 then
	
	if menu == 0 then
	screen:blit(15, 188+(pY*11), pointer)
	screen:print(30, 200, "Attack", white)	
	screen:print(30, 211, "Magic", white)			
	screen:print(30, 222, "Item", white)	

	elseif menu == 1 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in attacks do
	screen:print(30, 200 + (key*10), a, white)	
	end

	elseif menu == 2 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in magic do
	screen:print(30, 200 + (key*10), a, white)	
	end

	elseif menu == 3 then
	screen:blit(15, 188+(p2Y*11), pointer)
	for key,a in items do
	screen:print(30, 200 + (key*10), a, white)	
	end
	end

else
screen:print(30, 200, "Attack", gray)	
screen:print(30, 211, "Magic", gray)			
screen:print(30, 222, "Item", gray)	
end


ani = ani + 1
ani2 = ani * 24
if ani == 3 then
ani2 = 24
ani = -1
end

if bar:width() > barProgress then
barProgress = barProgress + speedStat * 3
end

if bar:width() > enemyBarProgress then
enemyBarProgress = enemyBarProgress + enemySpeed * 1.5
end

if barProgress >= bar:width() then
barProgress = bar:width()
yourTurn = 1
end

if enemyBarProgress >= bar:width() then
enemyBarProgress = bar:width()
enemyTurn = 1
end

screen:print(135, 200, "Hero:", white)
screen:blit(180, 200, bar, 0, 0, barProgress, bar:height(), true)	
screen:blit(180, 200, barBack, 0, 0, bar:width(), bar:height(), true)
hp = "HP: " .. hpLeft .. "/" .. hpTotal	
screen:print(320 - (string.len(hp) * 8), 200, hp, white)

screen:blit(90, 130, charBattle, ani2, 0, 24, 32, true)	
screen:blit(230, 130, baddyImage, ani2, 32, 24, 32, true)		


if enemyHPleft <= 0 or hpLeft <= 0 then   -->
break
end
				
						
screen.waitVblankStart(9)
screen:flip()														
														
	end														

if enemyHPleft <= 0 then -- >
screen:clear()
screen:print(150, 130, "You've Won!", white)
screen:flip()
defeated[table.getn(defeated)] = {enX, enY}
screen.waitVblankStart(60)
end


if hpLeft <= 0 then -- >
screen:clear()
screen:print(150, 130, "You've Lost!", white)
screen:flip()
defeated[table.getn(defeated)] = {enX, enY}
screen.waitVblankStart(60)
end

screen:clear()
end	






--Load up stats
file2 = io.open("stats.txt", "r")
hpLeft = tonumber(file2:read("*line"))
hpTotal = tonumber(file2:read("*line"))
mpLeft = tonumber(file2:read("*line"))
mpTotal = tonumber(file2:read("*line"))
speedStat = tonumber(file2:read("*line"))
speedStat = tonumber(file2:read("*line"))
attacks = split(file2:read("*line"))
magic = split(file2:read("*line"))
items = split(file2:read("*line"))
file2:close()




-- Clear screen and draw first map
screen:clear(black)
createMap("map1")
screen:flip()



while true do

pad = Controls.read()
if pad:select() then
break
end




if teleport(charX, charY) then
createMap(teleport(charX, charY))
ttt = 1
end

if pad:left() then
charAniY = 96
elseif pad:right() then
charAniY = 32
elseif pad:up() then
charAniY = 0
elseif pad:down() then
charAniY = 64
end

if ((pad:left() and loop == 0) or (dir == "left" and 4 > loop)) and collision(charX, charY, "left") == false and charX > 0 then
charX = charX - speed
dir = "left"

charAniY = 96
charAniX = charAniX + 24
	if charAniX == 96 then
	charAniX = 0
	end

if loop == 3 then
loop = -1
dir = ""
end

loop = loop + 1


elseif ((pad:right() and loop == 0) or (dir == "right" and 4 > loop)) and collision(charX, charY, "right") == false and 10*32 > charX then
charX = charX + speed
dir = "right"

charAniY = 32
charAniX = charAniX + 24
	if charAniX == 96 then
	charAniX = 0
	end
	
if loop == 3 then
loop = -1
dir = ""
end

loop = loop + 1

elseif ((pad:up() and loop == 0) or (dir == "up" and 4 > loop)) and collision(charX, charY, "up") == false and charY > 0  then
charY = charY - speed
dir = "up"

charAniY = 0
charAniX = charAniX + 24
	if charAniX == 96 then
	charAniX = 0
	end

if loop == 3 then
loop = -1
dir = ""
end

loop = loop + 1

elseif ((pad:down() and loop == 0) or (dir == "down" and 4 > loop)) and collision(charX, charY, "down") == false and 7*32 > charY then
charY = charY + speed
dir = "down"

charAniY = 64
charAniX = charAniX + 24
	if charAniX == 96 then
	charAniX = 0
	end

if loop == 3 then
loop = -1
dir = ""
end

loop = loop + 1	

else 
charAniX = 24
end





screen:clear(black)

aniX = charAniX
aniY = charAniY

if aniX == 72 then
aniX = 24
end



--Map and char
blitMap(0, 0)
screen:blit(charX + 6, charY, char, aniX, aniY, 24, 32, true)


screen:print(370, 10, "CharX = " .. charX, white)
screen:print(370, 20, "CharY = " .. charY, white)
screen:print(370, 35, "Objects", white)

for o,coor in objects do

 screen:print(370, (o*10)+45, coor[1] .. "," .. coor[2], white)

oldO = o
end

oldO = length(objects)*10 + 50

screen:print(370, oldO, "Portals", white)

for o,coor in teleports do
screen:print(370, oldO + (o*10) + 10, coor[2] .. "," .. coor[1], white)
end

screen:print(370, (oldO*10)+95, thisMap, white)

screen:print(370, 238, "Press Select", white)
screen:print(370, 248, "to Exit", white)



-- Talking to NPCs
for o,dd in npc do
	if pad:cross() then
 		if dd[1] * 32 == charX and dd[2] * 32 + 32 == charY and charAniY == 0 then
		npc[o][8] = 64
		dialogue(dd[5], dd[3])
		npc[o][8] = 64
		elseif dd[1] * 32 == charX and dd[2] * 32 - 32 == charY and charAniY == 64 then
		npc[o][8] = 0
		dialogue(dd[5], dd[3])
		npc[o][8] = 64
		elseif dd[1] * 32 + 32 == charX and dd[2] * 32 == charY and charAniY == 96 then
		npc[o][8] = 32
		dialogue(dd[5], dd[3])
		npc[o][8] = 64
		elseif dd[1] * 32 - 32 == charX and dd[2] * 32 == charY and charAniY == 32 then
		npc[o][8] = 96
		dialogue(dd[5], dd[3])
		npc[o][8] = 64
		end	
	end
end







-- Check if near enemies
for o,dd in enemy do
for l,ll in defeated do
	if ll[1] == dd[1] and ll[2] == dd[2] then
	dblit = 1 
	end
	end
	
	if dblit == 0 then
 		if dd[1] * 32 == charX and dd[2] * 32 + 32 == charY then
		battle(dd[3], dd[1], dd[2])
		baddy = dd[3]
		elseif dd[1] * 32 == charX and dd[2] * 32 - 32 == charY then
		battle(dd[3], dd[1], dd[2])
		baddy = dd[3]
		elseif dd[1] * 32 + 32 == charX and dd[2] * 32 == charY then
		battle(dd[3], dd[1], dd[2])
		baddy = dd[3]
		elseif dd[1] * 32 - 32 == charX and dd[2] * 32 == charY then
		battle(dd[3], dd[1], dd[2])
		baddy = dd[3]
		end	
	end
end



screen.waitVblankStart(7)
screen:flip()
if pad:square() then screen:save(appsDir.."/../".."ss.png") end
end